#include "canon.h"

#include "send_receive.cpp" // Fonctions pour envoyer et recevoir
#include "fonctions_dialogues.cpp" // Fonctions de dialogue avec le canon a electrons

CANON::CANON(QWidget *parent) : QMainWindow(parent)
{

  // pour faire plaisir a Guillaume, je remplace la virgule par un point
  QLocale::setDefault(QLocale(QLocale::English));

  ui.setupUi(this); // chargement de l'interface graphique
  port = NULL; // initialisation du port serie
}


/////////////////////////////////////////////
// Configuration de la connexion RS232
/////////////////////////////////////////////
void CANON::on_pushButton_1_1_clicked()
{
  // on affiche la fenetre
  fenetre_rs232.show();
}


/////////////////////////////////////////////
// Choix de Energy
/////////////////////////////////////////////
void CANON::on_pushButton_1_2_clicked()
{
  // on configure le port de communication
  int erreur;
  erreur = fenetre_rs232.connexion(port); // permet de se connecter a l'appareil
  if(erreur == -1)
    return;
  else
    port = (QextSerialPort *) erreur;

  // on recupere la valeur de Energy
  double value = ui.doubleSpinBox_1->value(); 
  value = (int) (value * 10); // multipliacation de la valeur pour supprimer la virgule
  QString value_string = QString::number(value);
  QString phrase = "po:0," + value_string;
  
  // envoie de la valeur sur le canon
  send_rs232(phrase);

  // reception
  receive_rs232();

  // lecture de toutes les valeurs du canon
  lecture();

  // fermeture du port
  port->close(); // on ferme le port
  delete port;
  port = NULL;
}

/////////////////////////////////////////////
// Choix de Source Voltage
/////////////////////////////////////////////
void CANON::on_pushButton_1_3_clicked()
{
  // on configure le port de communication
  int erreur;
  erreur = fenetre_rs232.connexion(port); // permet de se connecter a l'appareil
  if(erreur == -1)
    return;
  else
    port = (QextSerialPort *) erreur;

  // on recupere la valeur de Source Voltage
  double value = ui.doubleSpinBox_2->value(); 
  value = (int) (value * 1000); // multipliacation de la valeur pour supprimer la virgule
  QString value_string = QString::number(value);
  QString phrase = "po:1," + value_string;
  
  // envoie de la valeur sur le canon
  send_rs232(phrase);

  // reception
  receive_rs232();

  // lecture de toutes les valeurs du canon
  lecture();

  // fermeture du port
  port->close(); // on ferme le port
  delete port;
  port = NULL;
}

/////////////////////////////////////////////
// Choix de Focus
/////////////////////////////////////////////
void CANON::on_pushButton_1_4_clicked()
{
  // on configure le port de communication
  int erreur;
  erreur = fenetre_rs232.connexion(port); // permet de se connecter a l'appareil
  if(erreur == -1)
    return;
  else
    port = (QextSerialPort *) erreur;

  // on recupere la valeur de Focus
  double value = ui.doubleSpinBox_3->value(); 
  value = (int) (value * 10); // multipliacation de la valeur pour supprimer la virgule
  QString value_string = QString::number(value);
  QString phrase = "po:4," + value_string;
  
  // envoie de la valeur sur le canon
  send_rs232(phrase);

  // reception
  receive_rs232();

  // lecture de toutes les valeurs du canon
  lecture();

  // fermeture du port
  port->close(); // on ferme le port
  delete port;
  port = NULL;
}

/////////////////////////////////////////////
// Choix de Grid
/////////////////////////////////////////////
void CANON::on_pushButton_1_5_clicked()
{
  // on configure le port de communication
  int erreur;
  erreur = fenetre_rs232.connexion(port); // permet de se connecter a l'appareil
  if(erreur == -1)
    return;
  else
    port = (QextSerialPort *) erreur;

  // on recupere la valeur de Grid
  double value = ui.doubleSpinBox_4->value(); 
  value = (int) (value * 10); // multipliacation de la valeur pour supprimer la virgule
  QString value_string = QString::number(value);
  QString phrase = "po:2," + value_string;
  
  // envoie de la valeur sur le canon
  send_rs232(phrase);

  // reception
  receive_rs232();

  // lecture de toutes les valeurs du canon
  lecture();

  // fermeture du port
  port->close(); // on ferme le port
  delete port;
  port = NULL;
}

/////////////////////////////////////////////
// Lecture des valeurs
/////////////////////////////////////////////
void CANON::on_pushButton_1_6_clicked()
{
  // on configure le port de communication
  int erreur;
  erreur = fenetre_rs232.connexion(port); // permet de se connecter a l'appareil
  if(erreur == -1)
    return;
  else
    port = (QextSerialPort *) erreur;

  // lecture de toutes les valeurs du canon
  lecture();

  // fermeture du port
  port->close(); // on ferme le port
  delete port;
  port = NULL;
}

/////////////////////////////////////////////
// Lecture des valeurs
/////////////////////////////////////////////
void CANON::lecture(void)
{
  QString value;

  // Energy
  value = energy();
  ui.lineEdit_1->setText(value); 

  // Source Voltage
  value = sourcevoltage();
  ui.lineEdit_2->setText(value); 

  // Grid
  value = grid();
  ui.lineEdit_3->setText(value); 

  // Focus
  value = focus();
  ui.lineEdit_4->setText(value); 

  // Emission Current
  value = emission();
  ui.lineEdit_5->setText(value); 

  // Source Current
  value = source();
  ui.lineEdit_6->setText(value); 

}

